# I know practically nothing about Geometry, I came up with the 
# algorithm for this by sketching out a few dots and writing specs.

module Pip
  class Polygon
    attr_accessor :points
    def initialize(points)
      @points = points
    end
  
    def contains?(x,y)
      (vertical_boundaries_on(y).map{|k| [k,nil]} << [x,x]).sort_by{|one, two| one}.uniq.find_index([x,x]).odd?
    end
  
    def vertical_boundaries_on(target_y)
      lines.map do |p1, p2| 
        x = Polygon.coord_at(target_y, p1, p2)
        comparable = [p1[1], p2[1]].sort
        next if comparable.uniq.size == 1
        x if target_y.between?(comparable[0], comparable[1])
      end.compact.sort
    end
  
    def lines
      perms = []
      points.each_with_index {|n, i| perms << [n, points[i+1] || points[0]] }
      perms
    end
  
    def self.coord_at(y, p1, p2)
      x1, y1 = p1.map(&:to_f)
      x2, y2 = p2.map(&:to_f)
      (y - y1) / (y2 - y1) * (x2 - x1) + x1
    end
  end
end